<?php

namespace Televox\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use Lame\Lame;

class descargaArchivos extends Controller
{
    public function download(Request $request, $id)
    {
        $datos = $request->validate([
            'reproducir' => 'numeric|nullable|bail',
            'archive' => 'boolean|required|bail',
        ]);
        if (! $request->session()->get('descargar', false)) {
            abort(403, 'No tiene permisos para descargar grabaciones');
        } else {
            $salir = false;
            if (isset($datos['reproducir']) && $datos['reproducir'] == 1 && ! $request->session()->get('reproducir', false)) {
                $salir = true;
            }
            if (! $salir) {
                $recording_log = 'recording_log';
                if (array_key_exists('archive', $datos) && $datos['archive'] != null && $datos['archive'] == true) {
                    $recording_log = 'recording_log_archive';
                }
                switch (env('TIPO', 2)) {
                    case 2:
                    case 4:
                        $result = DB::connection('mysql')->table("$recording_log AS rl")->where('rl.recording_id', '=', $id)->where('rl.filename', 'LIKE', '%_'.$request->session()->get('idClientes'))->addSelect('rl.recording_id AS Nombre')->addSelect(DB::raw("date(rl.start_time) as 'FechaInicio'"))->addSelect(DB::raw("time(rl.start_time) AS 'HoraInicio'"))->addSelect(DB::raw("time(rl.end_time) AS 'HoraFin'"))->addSelect(DB::raw("sec_to_time(rl.length_in_sec) AS 'Duracion'"))->addSelect('rl.filename AS GRAB_ID')->addSelect('rl.user')->addSelect(DB::raw("substr(rl.location,Locate('MP3/',rl.location)+4) AS 'GRAB_FILE'"))->addSelect('rl.extension AS phone_number')->addSelect('rl.lead_id AS lead_id')->first();
                        if ($result) {
                            $realGRABFILE = $result->GRAB_FILE;
                            if (! \is_dir(public_path('.').'/audios')) {
                                mkdir(public_path('.').'/audios');
                            }
                            if (! file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                                if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$realGRABFILE")) {
                                    copy(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$realGRABFILE", public_path('audios').DIRECTORY_SEPARATOR.$result->GRAB_ID.'.mp3');
                                } else {
                                    if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR.str_replace('-', '/', $result->FechaInicio).'/'.str_replace(str_replace('-', '/', $result->FechaInicio).'/', '', $realGRABFILE))) {
                                        copy(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR.str_replace('-', '/', $result->FechaInicio).'/'.str_replace(str_replace('-', '/', $result->FechaInicio).'/', '', $realGRABFILE), public_path('audios').DIRECTORY_SEPARATOR.$result->GRAB_ID.'.mp3');
                                    } else {
                                        abort(404, 'No se logro encontrar la grabacion ');
                                    }
                                }
                            }
                            if (\file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                                if (isset($datos['reproducir']) && $datos['reproducir'] == 1) {
                                    DB::connection('mysql2')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 4, 'detalle' => 'El usuario '.$request->session()->get('usuario')." escucho la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                                    if (DB::connection('mysql2')->table('audios_listen')->where(['id_grab' => $result->GRAB_ID, 'id_usuario' => $request->session()->get('id')])->doesntExist()) {
                                        DB::connection('mysql2')->table('audios_listen')->insert(['id_grab' => $result->GRAB_ID, 'id_usuario' => $request->session()->get('id')]);
                                    }

                                } else {
                                    DB::connection('mysql2')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 3, 'detalle' => 'El usuario '.$request->session()->get('usuario')." descargo la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                                }

                                return response()->download(\public_path('audios/'.$result->GRAB_ID.'.mp3'));

                            } else {
                                abort(404, 'No se pudo descargar la grabacion');
                            }
                        } else {
                            abort(404, 'Grabacion no encontrada');
                        }
                        break;
                    case 3:
                        $result = DB::connection('mysql')->table('aurolog_grabaciones')->whereRaw("LEFT(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1),LENGTH(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1))-4) = ?", [$id])->addSelect('idGrabacion')->addSelect('ANI')->addSelect(BD::raw("CONCAT(DNIS,' ',digitos) as 'Destino'"))->addSelect(DB::raw("sec_to_time(hora) as 'horai'"))->addSelect(DB::raw("sec_to_time(hora+duracion) as 'horaf'"))->addSelect(DB::raw("sec_to_time(duracion) as 'duracion'"))->addSelect('extension')->addSelect(DB::raw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY) as 'fecha'"))->addSelect(DB::raw("substr(archivoVoz,Locate('/2',archivoVoz)+1) as 'GRAB_FILE'"))->addSelect(DB::raw("LEFT(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1),LENGTH(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1))-4) as 'GRAB_ID'"))->first();
                        if ($result) {
                            if (! \is_dir(public_path('.').'/audios')) {
                                mkdir(public_path('.').'/audios');
                            }
                            if (! \file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                                if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$result->GRAB_FILE")) {
                                    $encoding = new Settings\Encoding\Preset();
                                    $encoding->setType(Settings\Encoding\Preset::TYPE_STANDARD);
                                    $settings = new Settings\Settings($encoding);
                                    $lame = new Lame('/usr/bin/lame', $settings);
                                    try {
                                        $lame->encode(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$result->GRAB_FILE", public_path('audios').DIRECTORY_SEPARATOR.$result->GRAB_ID.'.mp3');
                                    } catch (RuntimeException $e) {
                                        abort(505, 'No se pudo convertir el audio<br>'.$e->getMessage());
                                    }
                                } else {
                                    abort(404, 'No se logro encontrar la grabacion ');
                                }
                            }
                            if (\file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                                if (isset($datos['reproducir']) && $datos['reproducir'] == 1) {
                                    DB::connection('mysql2')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 4, 'detalle' => 'El usuario '.$request->session()->get('usuario')." escucho la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                                    if (DB::connection('mysql2')->table('audios_listen')->where(['id_grab' => $result->GRAB_ID, 'id_usuario' => $request->session()->get('id')])->doesntExist()) {
                                        DB::connection('mysql2')->table('audios_listen')->insert(['id_grab' => $result->GRAB_ID, 'id_usuario' => $request->session()->get('id')]);
                                    }

                                } else {
                                    DB::connection('mysql2')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 3, 'detalle' => 'El usuario '.$request->session()->get('usuario')." descargo la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                                }

                                return response()->download(\public_path('audios/'.$result->GRAB_ID.'.mp3'));

                            } else {
                                abort(404, 'No se pudo descargar la grabacion');
                            }
                        } else {
                            abort(404, 'Grabacion no encontrada');
                        }
                        break;
                    case 1:
                        $result = DB::connection('mysql')->table('grab')->where('GRAB_ID', '=', $id)->addSelect(DB::raw("CONCAT(LEFT(GRAB_TIME_E,2),':',LEFT(RIGHT(GRAB_TIME_E,4),2),':',RIGHT(GRAB_TIME_E,2)) as 'GRAB_TIME_E'"))->addSelect(DB::raw("CONCAT(LEFT(GRAB_TIME_S,2),':',LEFT(RIGHT(GRAB_TIME_S,4),2),':',RIGHT(GRAB_TIME_S,2)) as 'GRAB_TIME_S'"))->addSelect(DB::raw("CONCAT(LEFT(GRAB_DATE,4),'/',LEFT(RIGHT(GRAB_DATE,4),2),'/',RIGHT(GRAB_DATE,2)) as 'GRAB_DATE'"))->addSelect('GRAB_FILE')->addSelect('GRAB_IP')->addSelect('GRAB_ID')->addSelect('GRAB_MACHINE')->addSelect('GRAB_EXT')->addSelect(DB::raw("TIME_FORMAT(SEC_TO_TIME(GRAB_DURATION),'%H:%i:%s') as 'GRAB_DURATION'"));
                        if ($result) {
                            if (! \is_dir(public_path('.').'/audios')) {
                                mkdir(public_path('.').'/audios');
                            }
                            if (! \file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                                if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$result->GRAB_FILE")) {
                                    $encoding = new Settings\Encoding\Preset();
                                    $encoding->setType(Settings\Encoding\Preset::TYPE_STANDARD);
                                    $settings = new Settings\Settings($encoding);
                                    $lame = new Lame('/usr/bin/lame', $settings);
                                    try {
                                        $lame->encode(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$result->GRAB_FILE", public_path('audios').DIRECTORY_SEPARATOR.$result->GRAB_ID.'.mp3');
                                    } catch (RuntimeException $e) {
                                        abort(505, 'No se pudo convertir el audio<br>'.$e->getMessage());
                                    }
                                } else {
                                    abort(404, 'No se logro encontrar la grabacion ');
                                }
                            }
                            if (\file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                                if (isset($datos['reproducir']) && $datos['reproducir'] == 1) {
                                    DB::connection('mysql2')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 4, 'detalle' => 'El usuario '.$request->session()->get('usuario')." escucho la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                                    if (DB::connection('mysql2')->table('audios_listen')->where(['id_grab' => $result->GRAB_ID, 'id_usuario' => $request->session()->get('id')])->doesntExist()) {
                                        DB::connection('mysql2')->table('audios_listen')->insert(['id_grab' => $result->GRAB_ID, 'id_usuario' => $request->session()->get('id')]);
                                    }

                                } else {
                                    DB::connection('mysql2')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 3, 'detalle' => 'El usuario '.$request->session()->get('usuario')." descargo la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                                }

                                return response()->download(\public_path('audios/'.$result->GRAB_ID.'.mp3'));
                            } else {
                                abort(404, 'No se pudo descargar la grabacion');
                            }
                        } else {
                            abort(404, 'Grabacion no encontrada');
                        }
                        break;
                }

            } else {
                abort(403, 'No tiene permisos para reproducir grabaciones');
            }
        }

    }

    public function downloadFiles(Request $request)
    {

        if (! $request->session()->get('descargar', false)) {
            abort(403, 'No tiene permisos para descargar grabaciones');
        } else {

            $string = [];
            switch (env('TIPO', 2)) {
                case 2:
                case 4:
                    $datos = $request->validate([
                        'tipoLlam' => 'numeric|between:-1,1|bail|nullable',
                        'identificador' => 'numeric|bail|nullable',
                        'usuario' => 'alpha_num|bail|nullable',
                        'nombre' => 'string|bail|nullable',
                        'telefono' => 'alpha_num|bail|nullable',
                        'cuenta' => 'alpha_num|bail|nullable',
                        'segundosinicial' => 'between:0,59|numeric|bail|required_with_all:minutosinicial,horasinicial',
                        'minutosinicial' => 'between:0,59|numeric|required_with_all:segundosinicial,horasinicial',
                        'horasinicial' => 'between:0,23|numeric|bail|required_with_all:minutosinicial,segundosinicial',
                        'segundosfinal' => 'between:0,59|numeric|bail|required_with_all:minutosfinal,horasfinal',
                        'minutosfinal' => 'between:0,59|numeric|bail|required_with_all:segundosfinal,horasfinal',
                        'horasfinal' => 'between:0,23|numeric|bail|required_with_all:minutosfinal,segundosfinal',
                        'inicio' => 'before_or_equal:today|date|bail|required_with_all:fminutosinicial,fhorasinicial,fsegundosinicial',
                        'fin' => 'after_or_equal:inicio|before_or_equal:today|date|bail|required_with_all:fminutosfinal,fhorasfinal,fsegundosfinal',
                        'fminutosinicial' => 'between:0,59|numeric|bail|required_with_all:fminutosinicial,fhorasinicial,inicio',
                        'fminutosinicial' => 'between:0,59|numeric|bail|required_with_all:fsegundosinicial,fhorasinicial,inicio',
                        'fhorasinicial' => 'between:0,23|numeric|bail|required_with_all:fminutosinicial,fsegundosinicial,inicio',
                        'fsegundosfinal' => 'between:0,59|numeric|bail|required_with_all:fminutosfinal,fhorasfinal,fin',
                        'fminutosfinal' => 'between:0,59|numeric|bail|required_with_all:fsegundosfinal,fhorasfinal,fin',
                        'fhorasfinal' => 'between:0,23|numeric|bail|required_with_all:fminutosfinal,fsegundosfinal,fin',
                        'status' => 'numeric|bail|nullable',
                        'escuchando' => 'boolean|bail|nullable',
                        'archive' => 'boolean|bail|required',
                        'campaign_id' => 'nullable|bail|string|required_with:list_id,status_id',
                        'list_id' => 'nullable|bail|string|required_with:status_id',
                        'status_id' => 'nullable|bail|string',
                        'ingroup_id' => 'nullable|bail|string',
                    ]);
                    $filtros = [];
                    $recording_log = 'recording_log';
                    if (array_key_exists('archive', $datos) && $datos['archive'] != null && $datos['archive'] == true) {
                        $recording_log = 'recording_log_archive';
                    }

                    if (array_key_exists('status', $datos) && $datos['status'] != null && $datos['status'] != 0) {
                        $filtros[] = ['ts.idStatus', '=', $datos['status']];
                    }
                    if (array_key_exists('campaign_id', $datos) && $datos['campaign_id'] != null) {
                        $filtros[] = ['vc.campaign_id', '=', $datos['campaign_id']];
                        if (array_key_exists('list_id', $datos) && $datos['list_id'] != null) {
                            $filtros[] = ['vls.list_id', '=', $datos['list_id']];
                        }
                        if (array_key_exists('status_id', $datos) && $datos['status_id'] != null) {
                            $filtros[] = ['vl.status', '=', $datos['status_id']];
                        }
                    } else {
                        if (array_key_exists('ingroup_id', $datos) && $datos['ingroup_id'] != null) {
                            $filtros[] = ['vc.campaign_id', '=', $datos['ingroup_id']];
                        }
                    }
                    $filtros[] = ['rl.filename', 'LIKE', '%_'.$request->session()->get('idClientes')];

                    if (array_key_exists('cuenta', $datos) && $datos['cuenta'] != null) {
                        $filtros[] = ['vl.vendor_lead_code', 'LIKE', "%{$datos['cuenta']}%"];
                    }
                    if (array_key_exists('identificador', $datos) && $datos['identificador'] != null) {
                        $filtros[] = ['rl.recording_id', '=', "{$datos['identificador']}"];
                    }
                    if (array_key_exists('telefono', $datos) && $datos['telefono'] != null) {
                        $filtros[] = ['rl.extension', 'LIKE', "%{$datos['telefono']}%"];
                    }
                    if (array_key_exists('nombre', $datos) && $datos['nombre'] != null) {
                        $filtros[] = ['rl.filename', 'LIKE', "%{$datos['nombre']}%"];
                    }
                    if (array_key_exists('usuario', $datos) && $datos['usuario'] != null) {
                        $filtros[] = ['rl.user', 'LIKE', "%{$datos['usuario']}%"];
                    }
                    if (array_key_exists('segundosinicial', $datos) && $datos['segundosinicial'] != null) {
                        $filtros[] = ['rl.length_in_sec', '>=', $datos['segundosinicial'] + $datos['minutosinicial'] * 60 + $datos['horasinicial'] * 3600];
                    }
                    if (array_key_exists('segundosfinal', $datos) && $datos['segundosfinal'] != null) {
                        $filtros[] = ['rl.length_in_sec', '<=', $datos['segundosfinal'] + $datos['minutosfinal'] * 60 + $datos['horasfinal'] * 3600];
                    }
                    if (array_key_exists('tipoLlam', $datos) && $datos['tipoLlam'] != null) {
                        if ($datos['tipoLlam'] > 0) {
                            $filtros[] = ['rl.filename', 'LIKE', 'IN_%'];
                        } else {
                            if ($datos['tipoLlam'] < 0) {
                                $filtros[] = ['rl.filename', 'LIKE', 'OUT_%'];
                            }
                        }
                    }

                    if ((array_key_exists('campaign_id', $datos) && $datos['campaign_id'] != null) || (array_key_exists('cuenta', $datos) && $datos['cuenta'] != null)) {
                        $results = DB::connection('mysql2')->table("$recording_log as rl")->crossJoin('vicidial_list AS vl')->leftJoin('tbl_status_grab AS tsg', 'tsg.id_grab', '=', 'rl.filename')->leftJoin('tbl_status AS ts', 'tsg.id_status', '=', 'ts.idStatus')->leftJoin('audios_listen AS al', 'al.id_grab', '=', 'rl.filename')->join('vicidial_lists AS vls', 'vls.list_id', '=', 'vl.list_id')->join('vicidial_campaigns AS vc', 'vc.campaign_id', '=', 'vls.campaign_id')->whereRaw('rl.lead_id=vl.lead_id')->where($filtros)->where(function ($q) use ($datos) {
                            if (array_key_exists('inicio', $datos)) {
                                $q->where(function ($qq) use ($datos) {
                                    $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['inicio'])))->whereTime('rl.start_time', '>=', date('H:i:s', strtotime("{$datos['fhorasinicial']}:{$datos['fminutosinicial']}:{$datos['fminutosinicial']}")));
                                })->orWhere(function ($qq) use ($datos) {
                                    $qq->whereDate('rl.start_time', '>', date('Y-m-d', strtotime($datos['inicio'])));
                                });
                            }

                        })->where(function ($q) use ($datos) {
                            if (array_key_exists('fin', $datos)) {
                                $q->where(function ($qq) use ($datos) {
                                    $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['fin'])))->whereTime('rl.start_time', '<=', date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}")));
                                })->orWhere(function ($qq) use ($datos) {
                                    $qq->whereDate('rl.start_time', '<', date('Y-m-d', strtotime($datos['fin'])));
                                });
                            }
                        })->where(function ($q) use ($request) {
                            $q->where(function ($qq) use ($request) {
                                $qq->where('al.id_usuario', '=', $request->session()->get('id'));
                            })->orWhere(function ($qq) {
                                $qq->whereRaw('al.id_usuario IS NULL');
                            });
                        });

                    } else {
                        if (array_key_exists('ingroup_id', $datos) && $datos['ingroup_id'] != null) {
                            $results = DB::connection('mysql2')->table("$recording_log as rl")->join('vicidial_closer_log AS vc', 'vc.vicidial_id', '=', 'vc.closecallid')->leftJoin('tbl_status_grab AS tsg', 'tsg.id_grab', '=', 'rl.filename')->leftJoin('tbl_comentarios AS tc', 'tc.id_grab', '=', 'rl.filename')->leftJoin('tbl_status AS ts', 'tsg.id_status', '=', 'ts.idStatus')->leftJoin('audios_listen AS al', 'al.id_grab', '=', 'rl.filename')->where($filtros)->where(function ($q) use ($datos) {
                                if (array_key_exists('inicio', $datos)) {
                                    $q->where(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['inicio'])))->whereTime('rl.start_time', '>=', date('H:i:s', strtotime("{$datos['fhorasinicial']}:{$datos['fminutosinicial']}:{$datos['fminutosinicial']}")));
                                    })->orWhere(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', '>', date('Y-m-d', strtotime($datos['inicio'])));
                                    });
                                }

                            })->where(function ($q) use ($datos) {
                                if (array_key_exists('fin', $datos)) {
                                    $q->where(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['fin'])))->whereTime('rl.start_time', '<=', date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}")));
                                    })->orWhere(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', '<', date('Y-m-d', strtotime($datos['fin'])));
                                    });
                                }
                            })->where(function ($q) use ($request) {
                                $q->where(function ($qq) use ($request) {
                                    $qq->where('al.id_usuario', '=', $request->session()->get('id'));
                                })->orWhere(function ($qq) {
                                    $qq->whereRaw('al.id_usuario IS NULL');
                                });
                            });

                        } else {
                            $results = DB::connection('mysql2')->table("$recording_log as rl")->leftJoin('tbl_status_grab AS tsg', 'tsg.id_grab', '=', 'rl.filename')->leftJoin('tbl_comentarios AS tc', 'tc.id_grab', '=', 'rl.filename')->leftJoin('tbl_status AS ts', 'tsg.id_status', '=', 'ts.idStatus')->leftJoin('audios_listen AS al', 'al.id_grab', '=', 'rl.filename')->where($filtros)->where(function ($q) use ($datos) {
                                if (array_key_exists('inicio', $datos)) {
                                    $q->where(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['inicio'])))->whereTime('rl.start_time', '>=', date('H:i:s', strtotime("{$datos['fhorasinicial']}:{$datos['fminutosinicial']}:{$datos['fminutosinicial']}")));
                                    })->orWhere(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', '>', date('Y-m-d', strtotime($datos['inicio'])));
                                    });
                                }

                            })->where(function ($q) use ($datos) {
                                if (array_key_exists('fin', $datos)) {
                                    $q->where(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', date('Y-m-d', strtotime($datos['fin'])))->whereTime('rl.start_time', '<=', date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}")));
                                    })->orWhere(function ($qq) use ($datos) {
                                        $qq->whereDate('rl.start_time', '<', date('Y-m-d', strtotime($datos['fin'])));
                                    });
                                }
                            })->where(function ($q) use ($request) {
                                $q->where(function ($qq) use ($request) {
                                    $qq->where('al.id_usuario', '=', $request->session()->get('id'));
                                })->orWhere(function ($qq) {
                                    $qq->whereRaw('al.id_usuario IS NULL');
                                });
                            });
                        }

                    }
                    $results = $results->limit(1000)->addSelect('rl.recording_id as Nombre')->addSelect(DB::raw("date(rl.start_time) as 'FechaInicio'"))->addSelect(DB::raw("time(rl.start_time) as 'HoraInicio'"))->addSelect(DB::raw("time(rl.end_time) as 'HoraFin'"))->addSelect(DB::raw("sec_to_time(rl.length_in_sec) as 'Duracion'"))->addSelect('rl.filename AS GRAB_ID')->addSelect('rl.user')->addSelect(DB::raw("substr(rl.location,Locate('MP3/',rl.location)+4) AS 'GRAB_FILE'"))->addSelect('rl.extension AS phone_number')->addSelect('rl.lead_id AS lead_id');
                    $results = $results->get();
                    foreach ($results as $result) {
                        $realGRABFILE = $result->GRAB_FILE;

                        if (! \is_dir(public_path('.').'/audios')) {
                            mkdir(public_path('.').'/audios');
                        }
                        if (! file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                            if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$realGRABFILE")) {
                                copy(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$realGRABFILE", public_path('audios').DIRECTORY_SEPARATOR.$result->GRAB_ID.'.mp3');
                            } else {
                                if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR.str_replace('-', '/', $result->FechaInicio).'/'.str_replace(str_replace('-', '/', $result->FechaInicio).'/', '', $realGRABFILE))) {
                                    copy(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR.str_replace('-', '/', $result->FechaInicio).'/'.str_replace(str_replace('-', '/', $result->FechaInicio).'/', '', $realGRABFILE), public_path('audios').DIRECTORY_SEPARATOR.$result->GRAB_ID.'.mp3');
                                } else {
                                    abort(404, 'No se logro encontrar la grabacion ');
                                }
                            }
                        }
                        if (\file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                            $string[] = public_path('audios')."/$result->GRAB_ID.mp3";
                            DB::connection('mysql2')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 3, 'detalle' => 'El usuario '.$request->session()->get('usuario')." descargo la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                        } else {
                            abort(404, 'No se pudo descargar la grabacion');
                        }
                    }
                    break;
                case 3:
                    $datos = $request->validate([
                        'nombre' => 'string|bail|nullable',
                        'extension' => 'numeric|bail|nullable',
                        'origen' => 'string|bail|nullable',
                        'destino' => 'numeric|bail|nullable',
                        'segundosinicial' => 'between:0,59|numeric|bail|required_with_all:minutosinicial,horasinicial',
                        'minutosinicial' => 'between:0,59|numeric|required_with_all:segundosinicial,horasinicial',
                        'horasinicial' => 'between:0,23|numeric|bail|required_with_all:minutosinicial,segundosinicial',
                        'segundosfinal' => 'between:0,59|numeric|bail|required_with_all:minutosfinal,horasfinal',
                        'minutosfinal' => 'between:0,59|numeric|bail|required_with_all:segundosfinal,horasfinal',
                        'horasfinal' => 'between:0,23|numeric|bail|required_with_all:minutosfinal,segundosfinal',
                        'inicio' => 'before_or_equal:today|date|bail|required_with_all:fminutosinicial,fhorasinicial,fsegundosinicial',
                        'fin' => 'after_or_equal:inicio|before_or_equal:today|date|bail|required_with_all:fminutosfinal,fhorasfinal,fsegundosfinal',
                        'fminutosinicial' => 'between:0,59|numeric|bail|required_with_all:fminutosinicial,fhorasinicial,inicio',
                        'fminutosinicial' => 'between:0,59|numeric|bail|required_with_all:fsegundosinicial,fhorasinicial,inicio',
                        'fhorasinicial' => 'between:0,23|numeric|bail|required_with_all:fminutosinicial,fsegundosinicial,inicio',
                        'fsegundosfinal' => 'between:0,59|numeric|bail|required_with_all:fminutosfinal,fhorasfinal,fin',
                        'fminutosfinal' => 'between:0,59|numeric|bail|required_with_all:fsegundosfinal,fhorasfinal,fin',
                        'fhorasfinal' => 'between:0,23|numeric|bail|required_with_all:fminutosfinal,fsegundosfinal,fin',
                        'pagina' => 'gte:0|numeric|bail|required',
                        'status' => 'numeric|bail|nullable',
                        'escuchando' => 'boolean|bail|nullable',
                    ]);
                    $filtros = [];
                    $filtros[] = ['cliente', '=', $request->session()->get('idClientes')];

                    if (array_key_exists('status', $datos) && $datos['status'] != null) {
                        $filtros[] = ['idStatus', '=', $datos['status']];
                    }
                    if (array_key_exists('escuchando', $datos) && $datos['escuchando'] != null && $datos['escuchando'] == true) {
                        $filtros[] = ['listened', '=', $request->session()->get('id')];
                    }
                    if (array_key_exists('nombre', $datos) && $datos['nombre'] != null) {
                        $filtros[] = ['idGrabacion', 'LIKE', "%{$datos['nombre']}%"];
                    }
                    if (array_key_exists('origen', $datos)) {
                        $filtros[] = ['ANI', 'LIKE', "%{$datos['origen']}%"];
                    }
                    if (array_key_exists('extension', $datos)) {
                        $filtros[] = ['extension', 'LIKE', "%{$datos['extension']}%"];
                    }
                    if (array_key_exists('segundosinicial', $datos) && $datos['segundosinicial'] != null) {
                        $filtros[] = ['duracion', '>=', $datos['segundosinicial'] + $datos['minutosinicial'] * 60 + $datos['horasinicial'] * 3600];
                    }
                    if (array_key_exists('segundosfinal', $datos) && $datos['segundosfinal'] != null) {
                        $filtros[] = ['duracion', '<=', $datos['segundosfinal'] + $datos['minutosfinal'] * 60 + $datos['horasfinal'] * 3600];
                    }

                    $results = DB::connection('mysql')->table('aurolog_grabaciones')->where($filtros)->where(function ($q) use ($datos) {
                        if (array_key_exists('inicio', $datos)) {
                            $q->where(function ($qq) use ($datos) {
                                $qq->whereRaw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY)=?", [date('Y-m-d', strtotime($datos['fin']))])->whereRaw('sec_to_time(hora)>=?', [date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}"))]);
                            })->orWhere(function ($qq) use ($datos) {
                                $qq->whereRaw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY)<", [date('Y-m-d', strtotime($datos['fin']))]);
                            });
                        }

                    })->where(function ($q) use ($datos) {
                        if (array_key_exists('destino', $datos)) {
                            $q->whereRaw("CONCAT(DNIS,' ',digitos) LIKE '?%'", [$datos['destino']]);
                        }
                    })->where(function ($q) use ($datos) {

                        if (array_key_exists('fin', $datos)) {
                            $q->where(function ($qq) use ($datos) {
                                $qq->whereRaw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY)=?", [date('Y-m-d', strtotime($datos['fin']))])->whereRaw('sec_to_time(hora)<=?', [date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}"))]);
                            })->orWhere(function ($qq) use ($datos) {
                                $qq->whereRaw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY)>", [date('Y-m-d', strtotime($datos['fin']))]);
                            });
                        }
                    })->limit(1000);
                    $results = $results->addSelect('idGrabacion')->addSelect('ANI')->addSelect(BD::raw("CONCAT(DNIS,' ',digitos) as 'Destino'"))->addSelect(DB::raw("sec_to_time(hora) as 'horai'"))->addSelect(DB::raw("sec_to_time(hora+duracion) as 'horaf'"))->addSelect(DB::raw("sec_to_time(duracion) as 'duracion'"))->addSelect('extension')->addSelect(DB::raw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY) as 'fecha'"))->addSelect(DB::raw("substr(archivoVoz,Locate('/2',archivoVoz)+1) as 'GRAB_FILE'"))->addSelect(DB::raw("LEFT(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1),LENGTH(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1))-4) as 'GRAB_ID'"))->orderByRaw('idunico DESC')->get();
                    foreach ($results as $result) {
                        if (! \is_dir(public_path('.').'/audios')) {
                            mkdir(public_path('.').'/audios');
                        }
                        if (! \file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                            if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$result->GRAB_FILE")) {
                                $encoding = new Settings\Encoding\Preset();
                                $encoding->setType(Settings\Encoding\Preset::TYPE_STANDARD);
                                $settings = new Settings\Settings($encoding);
                                $lame = new Lame('/usr/bin/lame', $settings);
                                try {
                                    $lame->encode(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$result->GRAB_FILE", public_path('audios').DIRECTORY_SEPARATOR.$result->GRAB_ID.'.mp3');
                                } catch (RuntimeException $e) {
                                    abort(505, 'No se pudo convertir el audio<br>'.$e->getMessage());
                                }
                            } else {
                                abort(404, 'No se logro encontrar la grabacion ');
                            }
                        }
                        if (\file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                            $string[] = public_path('audios')."/$result->GRAB_ID.mp3";
                            DB::connection('mysql2')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 3, 'detalle' => 'El usuario '.$request->session()->get('usuario')." descargo la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                        } else {
                            abort(404, 'No se pudo descargar la grabacion');
                        }
                    }
                    break;
                case 1:
                    $datos = $request->validate([
                        'nombre' => 'string|bail',
                        'extension' => 'numeric|bail',
                        'origen' => 'string|bail',
                        'destino' => 'numeric|bail',
                        'segundosinicial' => 'between:0,59|numeric|bail|required_with_all:minutosinicial,horasinicial',
                        'minutosinicial' => 'between:0,59|numeric|required_with_all:segundosinicial,horasinicial',
                        'horasinicial' => 'between:0,23|numeric|bail|required_with_all:minutosinicial,segundosinicial',
                        'segundosfinal' => 'between:0,59|numeric|bail|required_with_all:minutosfinal,horasfinal',
                        'minutosfinal' => 'between:0,59|numeric|bail|required_with_all:segundosfinal,horasfinal',
                        'horasfinal' => 'between:0,23|numeric|bail|required_with_all:minutosfinal,segundosfinal',
                        'inicio' => 'before_or_equal:today|date|bail|required_with_all:fminutosinicial,fhorasinicial,fsegundosinicial',
                        'fin' => 'after_or_equal:inicio|before_or_equal:today|date|bail|required_with_all:fminutosfinal,fhorasfinal,fsegundosfinal',
                        'fminutosinicial' => 'between:0,59|numeric|bail|required_with_all:fminutosinicial,fhorasinicial,inicio',
                        'fminutosinicial' => 'between:0,59|numeric|bail|required_with_all:fsegundosinicial,fhorasinicial,inicio',
                        'fhorasinicial' => 'between:0,23|numeric|bail|required_with_all:fminutosinicial,fsegundosinicial,inicio',
                        'fsegundosfinal' => 'between:0,59|numeric|bail|required_with_all:fminutosfinal,fhorasfinal,fin',
                        'fminutosfinal' => 'between:0,59|numeric|bail|required_with_all:fsegundosfinal,fhorasfinal,fin',
                        'fhorasfinal' => 'between:0,23|numeric|bail|required_with_all:fminutosfinal,fsegundosfinal,fin',
                    ]);
                    $filtros = [];
                    if (array_key_exists('nombre', $datos) && $datos['nombre'] != null) {
                        $filtros[] = ['GRAB_ID', 'LIKE', "%{$datos['nombre']}%"];
                    }
                    if (array_key_exists('destino', $datos)) {
                        $filtros[] = ['GRAB_MACHINE', 'LIKE', "%{$datos['destino']}%"];
                    }
                    if (array_key_exists('origen', $datos)) {
                        $filtros[] = ['GRAB_IP', 'LIKE', "%{$datos['origen']}%"];
                    }
                    if (array_key_exists('extension', $datos)) {
                        $filtros[] = ['GRAB_EXT', 'LIKE', "%{$datos['extension']}%"];
                    }
                    if (array_key_exists('segundosinicial', $datos) && $datos['segundosinicial'] != null) {
                        $filtros[] = ['GRAB_DURATION', '>=', $datos['segundosinicial'] + $datos['minutosinicial'] * 60 + $datos['horasinicial'] * 3600];
                    }
                    if (array_key_exists('segundosfinal', $datos) && $datos['segundosfinal'] != null) {
                        $filtros[] = ['GRAB_DURATION', '<=', $datos['segundosfinal'] + $datos['minutosfinal'] * 60 + $datos['horasfinal'] * 3600];
                    }
                    $limit = $datos['pagina'] * 20;
                    $results = DB::connection('mysql')->table('grab')->where($filtros)->where(function ($q) use ($datos) {
                        if (array_key_exists('inicio', $datos)) {
                            $q->where(function ($qq) use ($datos) {
                                $qq->whereDate('GRAB_DATE', date('Y-m-d', strtotime($datos['inicio'])))->whereTime('GRAB_TIME_S', '>=', date('H:i:s', strtotime("{$datos['fhorasinicial']}:{$datos['fminutosinicial']}:{$datos['fminutosinicial']}")));
                            })->orWhere(function ($qq) use ($datos) {
                                $qq->whereDate('GRAB_DATE', '>', date('Y-m-d', strtotime($datos['inicio'])));
                            });
                        }
                        if (array_key_exists('fin', $datos)) {
                            $q->where(function ($qq) use ($datos) {
                                $qq->whereDate('GRAB_DATE', date('Y-m-d', strtotime($datos['fin'])))->whereTime('GRAB_TIME_S', '<=', date('H:i:s', strtotime("{$datos['fhorasfinal']}:{$datos['fminutosfinal']}:{$datos['fminutosfinal']}")));
                            })->orWhere(function ($qq) use ($datos) {
                                $qq->whereDate('GRAB_DATE', '>', date('Y-m-d', strtotime($datos['fin'])));
                            });
                        }
                    })->limit(1000);
                    $results = $results->addSelect(DB::raw("CONCAT(LEFT(GRAB_TIME_E,2),':',LEFT(RIGHT(GRAB_TIME_E,4),2),':',RIGHT(GRAB_TIME_E,2)) as 'GRAB_TIME_E'"))->addSelect(DB::raw("CONCAT(LEFT(GRAB_TIME_S,2),':',LEFT(RIGHT(GRAB_TIME_S,4),2),':',RIGHT(GRAB_TIME_S,2)) as 'GRAB_TIME_S'"))->addSelect(DB::raw("time(rl.end_time) AS 'HoraFin'"))->addSelect(DB::raw("CONCAT(LEFT(GRAB_DATE,4),'/',LEFT(RIGHT(GRAB_DATE,4),2),'/',RIGHT(GRAB_DATE,2)) as 'GRAB_DATE'"))->addSelect('rl.filename AS GRAB_ID')->addSelect('GRAB_FILE')->addSelect('GRAB_IP')->addSelect('GRAB_ID')->addSelect('GRAB_MACHINE')->addSelect('GRAB_EXT')->addSelect(DB::raw("TIME_FORMAT(SEC_TO_TIME(GRAB_DURATION),'%H:%i:%s') as 'GRAB_DURATION'"))->orderByRaw("CONCAT(LEFT(GRAB_DATE,4),'-',LEFT(RIGHT(GRAB_DATE,4),2),'-',RIGHT(GRAB_DATE,2),' ',CONCAT(LEFT(GRAB_TIME_S,2),':',LEFT(RIGHT(GRAB_TIME_S,4),2),'/:',RIGHT(GRAB_TIME_S,2))) DESC")->get();
                    foreach ($results as $result) {
                        if (! \is_dir(public_path('.').'/audios')) {
                            mkdir(public_path('.').'/audios');
                        }
                        if (! \file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                            if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$result->GRAB_FILE")) {
                                $encoding = new Settings\Encoding\Preset();
                                $encoding->setType(Settings\Encoding\Preset::TYPE_STANDARD);
                                $settings = new Settings\Settings($encoding);
                                $lame = new Lame('/usr/bin/lame', $settings);
                                try {
                                    $lame->encode(\env('RUTAGRAB', '/mnt/Grabaciones').DIRECTORY_SEPARATOR."$result->GRAB_FILE", public_path('audios').DIRECTORY_SEPARATOR.$result->GRAB_ID.'.mp3');
                                } catch (RuntimeException $e) {
                                    abort(505, 'No se pudo convertir el audio<br>'.$e->getMessage());
                                }
                            } else {
                                abort(404, 'No se logro encontrar la grabacion ');
                            }
                        }
                        if (\file_exists(\public_path('audios/'.$result->GRAB_ID.'.mp3'))) {
                            $string[] = public_path('audios')."/$result->GRAB_ID.mp3";
                            DB::connection('mysql2')->table('tbl_log')->insertGetId(['idClientes' => $request->session()->get('idClientes'), 'ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 3, 'detalle' => 'El usuario '.$request->session()->get('usuario')." descargo la grabacion: $result->GRAB_ID Ext/Usuario: $result->GRAB_EXT: Fecha: $result->GRAB_DATE Hora: $result->GRAB_TIME_S"]);
                        } else {
                            abort(404, 'No se pudo descargar la grabacion');
                        }
                    }
                    break;
            }
            if (! \is_dir(public_path('.').'/ZIP')) {
                mkdir(public_path('.').'/ZIP');
            }

            $nombre = public_path('ZIP').'/archivozip'.rand(1, 10000000).'.zip';
            $zip = new \ZipArchive();
            if ($zip->open($nombre, \ZipArchive::CREATE) === true) {
                foreach ($string as $file) {
                    $zip->addFile($file, basename($file));
                }
                $zip->close();
                if (file_exists($nombre)) {
                    return response()->download($nombre, 'Grabaciones.zip');
                } else {
                    Log::debug('No pudo encontrar el archivo');
                    abort(404, 'No se pudieron conseguir las grabaciones');
                }
            } else {
                Log::debug('No pudo crear el archivo');
                abort(404, 'No se pudieron conseguir las grabaciones');
            }
        }
    }
}
